#include "gt9147.h"
#include "touch.h"
#include "ctiic.h"
#include "usart.h"
#include "delay.h" 
#include "string.h" 
#include "lcd.h" 
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//ALIENTEK STM32F407
//4.3ݴ-GT9147 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//:2014/5/7
//汾V1.0
//ȨУؾ
//Copyright(C) ӿƼ޹˾ 2014-2024
//All rights reserved									  
////////////////////////////////////////////////////////////////////////////////// 

//GT9147
//xֵ0x01E0=480
//yֵ0x0320=800
const u8 GT9147_CFG_TBL[]=
{ 
	0x62,0xE0,0x01,0x20,0x03,0x05,0x34,0xC0,0x01,0x08,
	0x28,0x0F,0x50,0x32,0x03,0x05,0x00,0x00,0x00,0x00,
	0x00,0x00,0x06,0x16,0x16,0x1F,0x14,0x89,0x28,0x0A,
	0x17,0x15,0x31,0x0D,0x00,0x00,0x08,0x22,0x04,0x11,
	0x00,0x00,0x00,0x00,0x00,0x03,0x82,0x08,0x08,0x00,
	0x00,0x0F,0x2C,0x94,0xC5,0x02,0x07,0x00,0x00,0x04,
	0x9D,0x10,0x00,0x84,0x14,0x00,0x70,0x19,0x00,0x5F,
	0x20,0x00,0x55,0x27,0x00,0x54,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,
	0x00,0x00,0x1A,0x18,0x16,0x14,0x12,0x10,0x0E,0x0C,
	0x0A,0x08,0x00,0x00,0x00,0x00,0x1F,0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,0x02,0x04,0x05,0x06,0x08,0x0A,0x0C,
	0x0E,0x1D,0x1E,0x1F,0x20,0x22,0x24,0x28,0x29,0xFF,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF6,
	0xFF,0xFF,0xFF,0xFF,0xCB,0x01,
};  

u16 CRC16(u8 *srcdata,u16 length)
{
	u16 crc=0xffff;
	u16 i,j;
	u8 value;
	for(i=0;i<length;i++)
	{
		for(j=0;j<8;j++)
		{
			value=((srcdata[i]<<j)&0x80)^((crc&0x8000)>>8);	
			crc<<=1;
			if(value!=0)
			{
				crc^=0x8005;
			}
		}
	}
	return crc;
}

#if 0

u8 GT5668_Send_Cfg(u8 mode)
{
	u8 buf[2];
	u8 i=0;
	buf[0]=0;
	buf[1]=mode;	//Ƿд뵽GT9147 FLASH?  Ƿ籣
	for(i=0;i<sizeof(GT9147_CFG_TBL);i++)buf[0]+=GT9147_CFG_TBL[i];//У
	buf[0]=(~buf[0])+1;
	GT9147_WR_Reg(GT_CFGS_REG,(u8*)GT9147_CFG_TBL,sizeof(GT9147_CFG_TBL));//ͼĴ
	GT9147_WR_Reg(GT_CHECK_REG,buf,2);//дУ,ø±
	return 0;
} 

#endif



//GT5668ò
//mode:0,浽flash
//     1,浽flash
u8 GT9147_Send_Cfg(u8 mode)
{
//	u8 checksum=0;
//	u8 buf[3];
//	u8 i=0;	
//	for(i=0;i<sizeof(GT5668_CFG_TBL);i++)
//	checksum +=GT5668_CFG_TBL[i];//У
//	checksum =(~checksum)+1;
//  buf[0]= 0X6E;//(checksum>>8);
//	buf[1]= 0X82;//checksum;
//	buf[2]= 0X01;//mode;	//Ƿд뵽GT5668 FLASH?  Ƿ籣
//	printf("\r\ncrc=%x",CRC16((u8*)GT5668_CFG_TBL,sizeof(GT5668_CFG_TBL)));
	GT9147_WR_Reg(GT_CFGS_REG,(u8*)GT9147_CFG_TBL,sizeof(GT9147_CFG_TBL));//ͼĴ
//	GT5668_WR_Reg(GT_CHECK_REG,buf,3);//дУ,ø±
	return 0;
	
	#if 0
	u8 buf[2];
	u8 i=0;
	buf[0]=0;
	buf[1]=mode;	//Ƿд뵽GT9147 FLASH?  Ƿ籣
	for(i=0;i<sizeof(GT9147_CFG_TBL);i++)buf[0]+=GT9147_CFG_TBL[i];//У
    buf[0]=(~buf[0])+1;
	GT9147_WR_Reg(GT_CFGS_REG,(u8*)GT9147_CFG_TBL,sizeof(GT9147_CFG_TBL));//ͼĴ
	GT9147_WR_Reg(GT_CHECK_REG,buf,2);//дУ,ø±
	return 0;
	#endif
} 



/*

u8 GT9147_Send_Cfg(u8 mode)
{
	u8 buf[2];
	u8 i=0;
	buf[0]=0;
	buf[1]=mode;	//Ƿд뵽GT9147 FLASH?  Ƿ籣
	for(i=0;i<sizeof(GT9147_CFG_TBL);i++)buf[0]+=GT9147_CFG_TBL[i];//У
  buf[0]=(~buf[0])+1;
	GT9147_WR_Reg(GT_CFGS_REG,(u8*)GT9147_CFG_TBL,sizeof(GT9147_CFG_TBL));//ͼĴ
	GT9147_WR_Reg(GT_CHECK_REG,buf,2);//дУ,ø±
	return 0;
} 

*/

//GT9147дһ
//reg:ʼĴַ
//buf:ݻ
//len:дݳ
//ֵ:0,ɹ;1,ʧ.
u8 GT9147_WR_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i;
	u8 ret=0;
	CT_IIC_Start();	
 	CT_IIC_Send_Byte(GT_CMD_WR);   	//д 	  0x28
	CT_IIC_Wait_Ack();
	CT_IIC_Send_Byte(reg>>8);   	//͸8λַ
	CT_IIC_Wait_Ack(); 	 										  		   
	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
	for(i=0;i<len;i++)
	{	   
    CT_IIC_Send_Byte(buf[i]);  	//
		ret=CT_IIC_Wait_Ack();
		if(ret)break;  
	}
    CT_IIC_Stop();					//һֹͣ	    
	return ret; 
}
//GT9147һ
//reg:ʼĴַ
//buf:ݻ
//len:ݳ			  
void GT9147_RD_Reg(u16 reg,u8 *buf,u8 len)
{
	u8 i; 
 	CT_IIC_Start();	
 	CT_IIC_Send_Byte(GT_CMD_WR);   //д 	0x28 
	CT_IIC_Wait_Ack();
 	CT_IIC_Send_Byte(reg>>8);   	  //͸8λַ
	CT_IIC_Wait_Ack(); 	 										  		   
 	CT_IIC_Send_Byte(reg&0XFF);   	//͵8λַ
	CT_IIC_Wait_Ack();  
 	CT_IIC_Start();  	 	   
	CT_IIC_Send_Byte(GT_CMD_RD);   //Ͷ		    0x29
	CT_IIC_Wait_Ack();	   
	for(i=0;i<len;i++)
	{	   
    	buf[i]=CT_IIC_Read_Byte(i==(len-1)?0:1); //	  
	} 
    CT_IIC_Stop();//һֹͣ    
} 
//ʼGT9147
//ֵ:0,ʼɹ;1,ʼʧ 
u8 GT9147_Init(void)
{
	u8 temp[5]; 
	//u8 temp1[2];
	GPIO_InitTypeDef  GPIO_InitStructure;	
	
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB|RCC_AHB1Periph_GPIOC, ENABLE);//ʹGPIOB,Cʱ

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 ;//PB1Ϊ(INT)
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;//ģʽ
  //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;//100MHz
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;//
  GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ
		
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;//PC13Ϊ(RST)
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
  GPIO_Init(GPIOC, &GPIO_InitStructure);//ʼ	
	
	CT_IIC_Init();  //ʼI2C  
	GT_RST=0;	    //λ
	delay_ms(10);
 	GT_RST=1;	   //ͷŸλ		    
	delay_ms(10); 
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;//PB1Ϊ(INT)
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;//ģʽ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼ	
	
	delay_ms(100);  
	GT9147_RD_Reg(GT_PID_REG,temp,4);//ȡƷID
	temp[4]=0;
	printf("CTP ID:%s\r\n",temp);	 //ӡID
	if(strcmp((char*)temp,"9147")==0)//ID==9147
	{
			temp[0]=0X02;			
			GT9147_WR_Reg(GT_CTRL_REG,temp,1);//λGT5668
			GT9147_RD_Reg(GT_CFGS_REG,temp,1);//ȡGT_CFGS_REGĴ
			printf("Default Ver:%d\r\n",temp[0]);
			printf("Default Ver:0x%x\r\n",temp[0]);
		
			GT9147_RD_Reg(0x80FF,temp,1);//ȡУͼĴ
			printf("Checksum:0x%x\r\n",temp[0]);
		
		
		
		//if(temp[0]<0X60)//Ĭϰ汾Ƚϵ,Ҫflash
		//if(temp[0]<0x60)//Ĭϰ汾Ƚϵ,Ҫflash
		/*
		{
			printf("Default Ver:%d\r\n",temp[0]);
			GT9147_Send_Cfg(1);//²
		}
		*/
			//GT9147_RD_Reg(GT_CFGS_REG,temp,1);
			//printf("Default Ver:%d\r\n",temp[0]);
		
		delay_ms(10);
		temp[0]=0X00;	 
		GT9147_WR_Reg(GT_CTRL_REG,temp,1);//λ   
		return 0;
		//printf(" CTP ID:%s\r\n",temp);
	} 
	return 1;
}
const u16 GT9147_TPX_TBL[5]={GT_TP1_REG,GT_TP2_REG,GT_TP3_REG,GT_TP4_REG,GT_TP5_REG};
//ɨ败(òѯʽ)
//mode:0,ɨ.
//ֵ:ǰ״̬.
//0,޴;1,д
u8 GT9147_Scan(u8 mode)
{
	u8 buf[4];
	u8 i=0;
	u8 res=0;
	u8 temp;
	u8 tempsta;
 	static u8 t=0;//Ʋѯ,ӶCPUռ   
	t++;
	if((t%10)==0||t<10)//ʱ,ÿ10CTP_Scanż1,ӶʡCPUʹ
	{
		GT9147_RD_Reg(GT_GSTID_REG,&mode,1);	//ȡ״̬  
 		if(mode&0X80&&((mode&0XF)<6))
		{
			temp=0;
			GT9147_WR_Reg(GT_GSTID_REG,&temp,1);//־ 		
		}		
		if((mode&0XF)&&((mode&0XF)<6))
		{
			temp=0XFF<<(mode&0XF);	//ĸתΪ1λ,ƥtp_dev.sta 
			tempsta=tp_dev.sta;			//浱ǰtp_dev.staֵ
			tp_dev.sta=(~temp)|TP_PRES_DOWN|TP_CATH_PRES; 
			tp_dev.x[4]=tp_dev.x[0];	//津0
			tp_dev.y[4]=tp_dev.y[0];
			for(i=0;i<5;i++)
			{
				if(tp_dev.sta&(1<<i))	//Ч?
				{
					GT9147_RD_Reg(GT9147_TPX_TBL[i],buf,4);	//ȡXYֵ
					if(tp_dev.touchtype&0X01)//
					{
						#if 0
						tp_dev.y[i]=((u16)buf[1]<<8)+buf[0];
						tp_dev.x[i]=800-(((u16)buf[3]<<8)+buf[2]);
						#endif
						
						tp_dev.x[i]=((u16)buf[1]<<8)+buf[0];
						tp_dev.y[i]=((u16)buf[3]<<8)+buf[2];
						
						//tp_dev.x[i]=((u16)buf[3]<<8)+buf[2];
						//tp_dev.y[i]=((u16)buf[1]<<8)+buf[0];
						
						
					}else
					{
						tp_dev.x[i]=((u16)buf[1]<<8)+buf[0];
						tp_dev.y[i]=((u16)buf[3]<<8)+buf[2];
					}  
					printf("x[%d]:%d,y[%d]:%d\r\n",i,tp_dev.x[i],i,tp_dev.y[i]);
				}			
			} 
			res=1;
			if(tp_dev.x[0]>lcddev.width||tp_dev.y[0]>lcddev.height)//Ƿ(곬)
			{ 
				if((mode&0XF)>1)		//,򸴵ڶݵһ.
				{
					tp_dev.x[0]=tp_dev.x[1];
					tp_dev.y[0]=tp_dev.y[1];
					t=0;				//һ,10,Ӷ
				}else					//Ƿ,Դ˴(ԭԭ)  
				{
					tp_dev.x[0]=tp_dev.x[4];
					tp_dev.y[0]=tp_dev.y[4];
					mode=0X80;		
					tp_dev.sta=tempsta;	//ָtp_dev.sta
				}
			}else t=0;							//һ,10,Ӷ
		}
	}
	if((mode&0X8F)==0X80)//޴㰴
	{ 
		if(tp_dev.sta&TP_PRES_DOWN)	//֮ǰǱµ
		{
			tp_dev.sta&=~(1<<7);	//ǰɿ
		}else						//֮ǰûб
		{ 
			tp_dev.x[0]=0xffff;
			tp_dev.y[0]=0xffff;
			tp_dev.sta&=0XE0;	//Ч	
		}	 
	} 	
	if(t>240)t=10;//´10ʼ
	return res;
}
 



























